<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>Online code utilities</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="web-ides">Web IDEs</h1>
    <p>
      <a href="https://ideone.com/">ideone</a> Ideone is an online compiler and
      debugging tool which allows youto compile source code and execute it
      online in more than 60 programming languages and share links to the
      code.<br />
      <a href="https://repl.it">repl.it</a> Like ideaone, can also install
      missing Python packages.<br />
      <a href="https://www.onlinegdb.com/">Onlilne GDB</a> Online compiler and
      debugger forC, C++, Python, Java, PHP, Ruby, Perl, Pascal, Fortran,
      Haskell, Objective-C, Assembly, HTML, CSS, JS, SQLite, Prolog, and
      more.<br />
      <a href="https://www.tutorialspoint.com/codingground.htm"
        >Coding Ground</a
      >
      Advanced IDEs for C/C++, C#, GO, Java, PHP, Perl, Python, Octave/MATLOAB,
      R, Ruby, Scala, and compiler/interpreter for many other languages and
      frameworks.<br />
      <a href="https://www.jdoodle.com/">JDOODLE</a> very similar to ideone but
      a somewhat different set of languagse/compilers.
    </p>
    <p>
      Dedicated: <a href="https://jsfiddle.net/">JSFiddle</a> Online JavaScript,
      CSS, HTML or CoffeeScript code editor. Option to add various web
      frameworks. <a href="https://dotnetfiddle.net/">.NET Fiddle</a> Online
      compiler for C#, VB.NET, and F# with .NET 4.5 &amp; Roslyn 2.0. Option to
      install additional nuget packages.
    </p>
    <p>(Cloud workspaces: https://codenvy.com/, https://codeanywhere.com/)</p>
    <h1 id="regex">RegEx</h1>
    <h2 id="online-tester-code-generator">
      Online Tester &amp; Code Generator
    </h2>
    <p>
      <a href="https:/regex101.com">regex101</a> Online regex tester for PHP,
      PCRE, JavaScript and Python that highlights pattern and matches on the
      fly.<br />
      https://regexr.com/ Online regex tester with gut regex replace and explain
      functionality.<br />
      https://www.debuggex.com/ Can show neat expression diagrams (not active
      anymore).<br />
      https://regexper.com/ also shows expression diagrams.<br />
      https://myregextester.com/index.php Allows to optimize patterns (I guess
      this is based on this Perl’s
      <a
        href="http://search.cpan.org/~dankogai/Regexp-Optimizer-0.23/lib/Regexp/Optimizer.pm"
        >Regexp::Optimizer</a
      >).
    </p>
    <h3 id="libraries">Libraries</h3>
    <p>
      http://regexlib.com/ Regular Expression Library. Currently has 7601
      expressions from 2492 contributors (most are subpar IMHO).
    </p>
    <h3 id="generator">Generator</h3>
    <p>
      <a href="txt2re.com">txt2re</a>: regular expression generator (with code
      generator for perl php python java javascript coldfusion c c++ ruby vb
      vbscript j# c# c++.net vb.net)
    </p>
    <h3 id="net-regex">.NET Regex</h3>
    <p>
      http://regexstorm.net/tester<br />
      http://regexhero.net/tester/<br />
      http://www.beansoftware.com/Test-Net-Regular-Expressions/Split-String.aspx
    </p>
    <h3 id="java-regex">Java Regex</h3>
    <p>http://java-regex-tester.appspot.com/</p>
    <h3 id="perl">Perl</h3>
    <p>
      http://www.regexplanet.com/advanced/perl/index.html<br />
      http://www.regexe.com/
    </p>
    <h3 id="r">R</h3>
    <p>
      https://spannbaueradam.shinyapps.io/r_regex_tester/<br />
      http://rextester.com/l/r_online_compiler
    </p>
    <h3 id="ruby">Ruby</h3>
    <p>http://rubular.com/</p>
    <h3 id="htaccess-tester">htaccess tester</h3>
    <p>http://htaccess.mwl.be/</p>
    <h3 id="google-analytics-regex-tester">Google Analytics Regex Tester</h3>
    <p>
      http://www.analyticsmarket.com/freetools/regex-tester (and a general
      <a
        href="https://www.apasters.com/blog/regex-guide-google-analytics-tag-manager/"
        >GA RE usage guide</a
      >)
    </p>
    <h3 id="regex-reverse-pattern-generator">
      Regex Reverse Pattern generator
    </h3>
    <p>
      <a href="https://github.com/google/sre_yield">sre_yield</a>: generate all
      values that can match a given regular expression, or count possible
      matches efficiently<br />
      <a href="https://github.com/bluezio/xeger">Xeger</a>: Java library for
      generating strings that match a specific regular expression.<br />
      <a href="https://github.com/bluezio/xeger">PyXeger</a>: Java library for
      generating strings that match a specific regular expression.
    </p>
    <h1 id="general-languages">General Languages</h1>
    <p>https://www.tutorialspoint.com/codingground.htm</p>
    <h2 id="net">.NET</h2>
    <p>https://dotnetfiddle.net/</p>
    <h2 id="php">PHP</h2>
    <p>
      <a href="http://sandbox.onlinephpfunctions.com/">PHP Sandbox</a>: Allows
      to test PHP code on many php versions.<br />
      https://3v4l.org/ allows to run over 200 different PHP versions (including
      HHVM, etc.) in parallel - excellent for version compatibility tests<br />
      http://c9.io An online IDE that supports many languages (free for personal
      use).<br />
      http://phpfiddle.org/ A PHP online IDE with some extra resources like code
      search (saved, external code).
    </p>
    <h2 id="python">Python</h2>
    <p>
      https://www.onlinegdb.com/online_python_debugger<br />
      <a href="https://github.com/asciimoo/exrex">EXREX</a> is a command line
      tool and python module that generates all - or random - matching strings
      to a given regular expression and more.
    </p>
    <h2 id="perl-1">Perl</h2>
    <p>
      http://rextester.com/l/perl_online_compiler<br />
      https://www.jdoodle.com/execute-perl-online<br />
      https://www.tutorialspoint.com/execute_perl_online.php
    </p>
    <h2 id="html">HTML</h2>
    <p>https://html-cleaner.com/ HTML/CSS/JS Cleaner</p>
    <h2 id="json">JSON:</h2>
    <p>
      Query test: http://www.jsonquerytool.com/#/JavaScript<br />
      Sort array: https://aruljohn.com/jsonsort/<br />
      Generate C# classes from JSON: http://json2csharp.com/ (Desktop tool:
      http://jsonclassgenerator.codeplex.com/)<br />
      <a href="http://convertjson.com/">ConvertJson.com</a> FromJson(to XML,
      HTML, CSV, SQL, YAML), ToJson, JsonTools (Lint, Viewer, Format, Path
      Analyzer)
    </p>
    <h2 id="sql">SQL</h2>
    <p>
      http://sqlfiddle.com/ (MySQL, Oracle, PosgreSQL, SQLite, MS SQL 2014)<br />
      https://sqltest.net/ (MySQL, Oracle)<br />
      https://sqlizer.io/
    </p>
    <h3 id="sql-formater">SQL Formater</h3>
    <p>
      https://sqlformat.org/ (online formatting service)<br />
      http://poorsql.com/ (Poor Man’s SQL Formatter online,
      <a href="http://architectshack.com/PoorMansTSqlFormatter.ashx#Download_4"
        >download for VS, SMSS, Np++, etc.</a
      >).
    </p>
    <h1 id="utilities">Utilities</h1>
    <h2 id="code-beautifier-syntax-highlither">
      Code beautifier &amp; Syntax Highlither
    </h2>
    <p>
      https://codebeautify.org/<br />
      https://tohtml.com/ Syntax Highlither for varius languages (useful for
      HTML &amp; RTF text)
    </p>
    <h3 id="character-set-conversion">Character Set Conversion</h3>
    <p>http://www.fileformat.info/convert/text/charset.htm</p>
    <h2 id="other">Other</h2>
    <p>
      Arul’s network and other technical utilities: View your IP, country, ISP
      name, OS, browser/UA.<br />
      Convert IP address to hostname and vice versa, text case convert, UNIX
      timestamp to date, hash generator<br />
      https://aruljohn.com/
    </p>
    <p>Record and share Linux/Mac terminal sessions: https://asciinema.org/</p>
  </body>
</html>
